<template>
  <div
    class="serie-banner-mobile"
    :style="{
      'background-image': `url(${bannerImage})`
    }"
  >
    <div class="overlay"></div>
    <div class="album-content">
      <AppTitle class="serie-title text--white" :title="serie.name" />
      <StarRank :avgstar="serie.rate" :countnote="serie.rateAmount" />
      <div class="open-modal icon-text" @click="showResumeModal = true">
        <img :src="require('~/assets/images/ic-info-white.svg')" />
        <div>{{ $t('serie.know_more') }}</div>
      </div>
      <a
        v-if="continueReadingAlbum"
        :href="continueReadingAlbum"
        class="serie-btn"
        @click.prevent="
          $utils.gtmEvent(
            {
              event: 'gtm.event',
              EventCategory: 'Clic_Bouton',
              EventAction: 'Lire',
              EventLabel: `${serie.shelf.name}_${serie.name}`
            },
            continueReadingAlbum
          )
        "
      >
        <AppButton :theme="btnTheme">
          {{ $t('serie.read') }}
        </AppButton>
      </a>
      <div class="actions">
        <div
          v-if="!serie.isfollowing"
          class="icon-text"
          @click="$emit('followSerie')"
        >
          <img :src="require('~/assets/images/ic-follow.svg')" />
          <div>{{ $t('followers.follow') }}</div>
        </div>
        <div
          v-if="serie.isfollowing"
          class="icon-text gray"
          @click="$emit('followSerie')"
        >
          <img :src="require('~/assets/images/ic-follow.svg')" />
          <div>{{ $t('followers.unfollow') }}</div>
        </div>
        <div class="icon-text" @click="showShareModal = !showShareModal">
          <img
            :style="{ 'padding-top': '2px' }"
            :src="require('~/assets/images/ic-share.svg')"
          />
          <div>{{ $t('followers.share') }}</div>
        </div>
      </div>
    </div>
    <AppModal
      v-if="showShareModal"
      :no-default="true"
      :closing-cross="true"
      :full-width="true"
      class="share-modal"
      @close="showShareModal = false"
    >
      <template v-slot:header>
        <h2
          class="text--md--home heading heading--md text--primary text--bold share-modal-header"
        >
          {{ $t('followers.share_modal') }}
        </h2>
      </template>
      <template v-slot:body>
        <div class="share-modal-content">
          <img
            :src="require('~/assets/images/ic-facebook.svg')"
            @click="$emit('facebookShare')"
          />
          <a
            href="https://twitter.com/share"
            @click.prevent="
              $utils.gtmEvent(
                {
                  event: 'gtm.event',
                  EventCategory: 'Social',
                  EventAction: 'twitter',
                  EventLabel: `Partage_${serie.name}`
                },
                'https://twitter.com/share'
              )
            "
          >
            <img :src="require('~/assets/images/ic-twitter.svg')" />
          </a>
          <a
            :href="`mailto:?Subject=${serie.name}&amp;Body=${currentSerieUrl}`"
            @click.prevent="
              $utils.gtmEvent(
                {
                  event: 'gtm.event',
                  EventCategory: 'Social',
                  EventAction: 'mail',
                  EventLabel: `Partage_${serie.name}`
                },
                `mailto:?Subject=${serie.name}&amp;Body=${currentSerieUrl}`
              )
            "
          >
            <img :src="require('~/assets/images/ic-mail.svg')" />
          </a>
        </div>
      </template>
    </AppModal>
    <AppModal
      v-if="showResumeModal"
      :no-default="true"
      :closing-cross="true"
      :full-width="true"
      @close="showResumeModal = false"
    >
      <template v-slot:body>
        <SerieResumeModal :serie="serie" />
        <SerieSuperReaderMobile
          v-if="serie.SRreview && serie.SRreview.id"
          :serie="SRSerieData"
          :sr="serie.SRreview"
          class="super-reader"
        />
      </template>
    </AppModal>
  </div>
</template>

<script>
import AppTitle from '~/components/ui/AppTitle'
import AppButton from '~/components/ui/AppButton'
import AppModal from '~/components/ui/AppModal'
import StarRank from '~/components/ui/StarRank'
import SerieResumeModal from '~/components/Serie/SerieResumeModal'
import SerieSuperReaderMobile from '~/components/Serie/SerieSuperReaderMobile'

export default {
  components: {
    AppTitle,
    AppButton,
    StarRank,
    AppModal,
    SerieResumeModal,
    SerieSuperReaderMobile
  },
  props: {
    serie: {
      type: Object,
      required: true
    },
    isSubscription: {
      type: Boolean,
      required: true
    },
    connected: {
      type: Boolean,
      required: true
    }
  },
  data() {
    return {
      showResumeModal: false,
      showShareModal: false,
      currentSerieUrl: ''
    }
  },
  computed: {
    bannerImage() {
      let bannerImg

      // webtoon case
      if (+this.serie.shelf.id === 6) {
        bannerImg = `${this.$config.izneoUrl}/${this.$i18n.locale}/images/serie/${this.serie.id}.jpg?v=${this.serie.version}`
      } else if (this.isSubscription && this.serie.coverAbo) {
        bannerImg = `${this.$config.izneoUrl}/${this.$i18n.locale}/images/album/${this.serie.coverAbo}.jpg?v=${this.serie.coverAboVersion}`
      } else {
        bannerImg = `${this.$config.izneoUrl}/${this.$i18n.locale}/images/album/${this.serie.cover}.jpg?v=${this.serie.coverVersion}`
      }

      return bannerImg
    },
    btnTheme() {
      const abo = this.isSubscription

      return abo ? 'secondary' : ''
    },
    continueReadingAlbum() {
      if (!this.serie.continueReadingAlbum) return ''
      const albumUrl = this.$utils.aboArea()
        ? this.serie.continueReadingAlbum.urlAbo
        : this.serie.continueReadingAlbum.url

      return (
        `${this.host}${albumUrl}` +
        (this.currentSerieUrl ? `?exiturl=${this.currentSerieUrl}` : '')
      )
    },
    host() {
      return this.$config.izneoUrl
    },
    SRSerieData() {
      return {
        shelf: this.serie.shelf.slug,
        slug: this.serie.forUrl,
        genre: this.serie.genre.slug,
        SRreviewCnt: this.serie.SRreviewCnt,
        rate: this.serie.rate,
        rateAmount: this.serie.rateAmount
      }
    }
  },
  mounted() {
    this.currentSerieUrl = window.location.href
  }
}
</script>

<style lang="scss">
.serie-banner-mobile {
  position: relative;
  background: #272626;
  background-repeat: no-repeat;
  background-size: cover;
  background-position: center;
  min-height: 335px;
  padding: 2rem 1rem;

  .overlay {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background: rgba(0, 0, 0, 0.4);
  }

  .album-content {
    position: relative;
    display: flex;
    flex-direction: column;

    .serie-title {
      font-size: 36px;
    }

    .star-rank {
      margin: 1rem 0;
    }

    .open-modal {
      margin-top: 1rem;
    }

    .serie-btn {
      width: fit-content;
      margin: auto;
      margin-top: 6rem;
      margin-bottom: 2rem;
    }

    .icon-text {
      cursor: pointer;
      text-transform: uppercase;
      font-family: DINCond-Bold;
      font-weight: bold;
      letter-spacing: 0.5px;
      font-size: 20px;
      color: #fff;
      display: flex;

      img {
        padding-right: 0.5rem;
      }

      div {
        padding-top: 5px;
        display: inline-block;
      }
    }

    .actions {
      display: flex;
      justify-content: space-around;
      align-items: center;
    }
  }

  .share-modal {
    .share-modal-header {
      padding: 1.75rem 0;
    }

    .share-modal-content {
      display: flex;
      justify-content: center;
      padding: 0 2rem;
      overflow: hidden;

      img {
        cursor: pointer;
        margin: 0 0.5rem;
      }
    }
  }
}
</style>
